<?php

namespace STM\Club\Member;

use STM\StmFactory;

/**
 * Test class for ClubMember.
 * Generated by PHPUnit on 2012-03-29 at 20:52:19.
 * @group team_club
 */
class ClubMemberTest extends \PHPUnit_Framework_TestCase {

    private $club;
    private $person;
    private $position;

    protected function setUp() {
        $this->club = StmFactory::find()->Club->findById(1);
        $this->person = StmFactory::find()->Person->findById(1);
        $this->position = StmFactory::find()->PersonPosition->findById(1);
    }

    public function testFind_club_member_in_position() {
        if ($this->club && $this->person && $this->position) {
            $club_member = StmFactory::find()->ClubMember->findById($this->club, $this->person, $this->position);
            parent::assertTrue($club_member == false || $club_member instanceof ClubMember);
        }
    }

    public function testFind_by_club() {
        $this->assert_find_method('club', 'findByClub');
    }

    public function testFind_by_person() {
        $this->assert_find_method('person', 'findByPerson');
    }

    private function assert_find_method($attribute, $method) {
        if ($this->$attribute) {
            $club_members = StmFactory::find()->ClubMember->$method($this->$attribute);
            parent::assertTrue(is_array($club_members));
            foreach ($club_members as $member) {
                parent::assertInstanceOf('\STM\Club\Member\ClubMember', $member);
            }
        }
    }
    
    public function testCreate() {
        parent::markTestSkipped('test in ClubMemberValidatorTest');
    }

    public function testUpdate_person_position() {
        parent::markTestSkipped('test in ClubMemberValidatorTest');
    }

    public function testDelete_person_from_club() {
        parent::markTestSkipped('only DB fail');
    }

}

?>
